/*
 * Copyright (C) 1998 Angus Mackay. All rights reserved.
 * See the file COPYING for details.
 *
 */

#ifndef _SINUS_H
#define _SINUS_H

#include "sized_types.h"

/*
 * MS RIFF WAV header
 */
struct wavFormatChunk
{
  char      chunkID[4];
  INT32   chunkSize;

  INT16   FormatTag;
  UINT16 Channels;
  UINT32 SamplesPerSec;
  UINT32 AvgBytesPerSec;
  UINT16 BlockAlign;
  UINT16 BitsPerSample;
};

/*
 * our representation of an audio sample
 */
struct wave_t
{
  void *data;
  int data_size;

  int bits;
  int rate;
  int channels;
  int samples;

  // the size of 1 data point, ceil(bits/8)
  int point_size;

  double audio_min;
  double audio_max;

  // these functions are used to support 8/16/32 bit samples
  void (*pack)(void *, double);
  double (*unpack)(void *);
};


#ifdef DEBUG
#define dprintf(x) if(options & OPT_DEBUG) \
{ \
  fprintf(stderr, "%s,%d: ", __FILE__, __LINE__); \
    fprintf x; \
}
#define dprint(x) if(options & OPT_DEBUG) \
{ \
    fprintf x; \
}
#else
#  define dprintf(x)
#  define dprint(x)
#endif

extern char *program_name;
extern char *audio_dev;
extern int options;

#define OPT_DEBUG       0x0001
#define OPT_NOPLAY      0x0002

#endif
